proj4 = require "proj4"
mercator = proj4.defs('GOOGLE')
wgs84 = proj4.defs('WGS84')

class ProjectionUtils

  constructor: () ->
    @origin_shift = 2 * Math.PI * 6378137 / 2.0

  geographic_to_meters: (xLon, yLat) ->
    return  proj4(wgs84, mercator, [xLon, yLat])

  meters_to_geographic: (mx, my) ->
    return  proj4(mercator, wgs84, [mx, my])

  geographic_extent_to_meters: (extent) ->
    [xmin, ymin, xmax, ymax] = extent
    [xmin, ymin] = @geographic_to_meters(xmin, ymin)
    [xmax, ymax] = @geographic_to_meters(xmax, ymax)
    return [xmin, ymin, xmax, ymax]

  meters_extent_to_geographic: (extent) ->
    [xmin, ymin, xmax, ymax] = extent
    [xmin, ymin] = @meters_to_geographic(xmin, ymin)
    [xmax, ymax] = @meters_to_geographic(xmax, ymax)
    return [xmin, ymin, xmax, ymax]

module.exports =
  ProjectionUtils : ProjectionUtils
